#!/usr/bin/env python

"""
Program code and data representations.
"""

class Block:

    "A code block."

    def __init__(self):
        self.code = []
        self.location = None

    def __repr__(self):
        return "Block(%r, location=%r)" % (id(self), self.location)

    def as_raw(self, objtable, paramtable):
        for i, item in enumerate(self.code):
            if hasattr(item, "location"):
                item.location = location + i
        return self.code

class DataObject:

    "A representation of a raw program data object."

    def __init__(self, classcode, attrcode, codeaddr, codedetails, instance, name, funccode=None):
        self.classcode = classcode
        self.attrcode = attrcode
        self.codeaddr = codeaddr
        self.codedetails = codedetails
        self.instance = instance
        self.name = name
        self.funccode = funccode

    def __repr__(self):
        return "%r # %s" % ((self.classcode, self.attrcode, self.codeaddr, self.codedetails, self.instance, self.funccode), self.name)

# vim: tabstop=4 expandtab shiftwidth=4
